/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20090521
 *
 * Disassembly of /Volumes/Chameleon/Extra/dsdt.aml, Mon Nov  9 20:15:55 2009
 *
 *
 * Original Table Header:
 *     Signature        "DSDT"
 *     Length           0x00002654 (9812)
 *     Revision         0x01 **** ACPI 1.0, no 64-bit math support
 *     Checksum         0x88
 *     OEM ID           "GBT   "
 *     OEM Table ID     "GBTUACPI"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20090521 (537462049)
 *
 * This DSDT is based on mm67's but amended for the GA-EP45-DS3L.
 *
 */
DefinitionBlock ("/Volumes/Chameleon/Extra/dsdt.aml", "DSDT", 1, "GBT   ", "GBTUACPI", 0x00001000)
{
    Scope (_PR) // Processor Tree - revised layout as MasterChief's latest DSDT v3.3
    {
        Name (PSS, Package (0x05) // For Intel Core 2 Duo E7300 @ 2.66Ghz
        {
            Package (0x06) { 2670, 0, 10, 10, 0x0A1D, 0 },
            Package (0x06) { 2403, 0, 10, 10, 0x091D, 1 },
            Package (0x06) { 2136, 0, 10, 10, 0x081C, 2 },
            Package (0x06) { 1869, 0, 10, 10, 0x071B, 3 },
            Package (0x06) { 1602, 0, 10, 10, 0x061A, 4 }
        })

        Name (PSD, Package (0x05)
        {
            0x05,
            0x00,
            0x00,
            0xFC, // Double-checked the 0xFC value with ACPISpec v4.0 pdf
            0x02  // Number of Processors - If you have a Quad core CPU then this value should read 0x04
        })

        Name (CST, Package (0x04)
        {
            0x03, 
            Package (0x04) {ResourceTemplate () {Register (FFixedHW, 1, 2, 0x000,,)},0x01,0x01,0x03E8},
            Package (0x04) {ResourceTemplate () {Register (SystemIO, 8, 0, 0x414,,)},0x02,0x01,0x01F4},
            Package (0x04) {ResourceTemplate () {Register (SystemIO, 8, 0, 0x415,,)},0x03,0x55,0xFA} 
        })

        Processor (CPU0, 0x0, 0x00000410, 0x06)
        {
            Alias (PSS, _PSS)
            Alias (PSD, _PSD)
            Alias (CST, _CST)
        }

        Processor (CPU1, 0x01, 0x00000410, 0x06)
        {
            Alias (PSS, _PSS)
            Alias (PSD, _PSD)
            Alias (CST, _CST)
        }
    }

    Name (_S0, Package (0x04){Zero,Zero,Zero,Zero})
    Name (_S1, Package (0x04){One,Zero,Zero,Zero})
    Name (_S3, Package (0x04){0x05,Zero,Zero,Zero})
    Name (_S4, Package (0x04){0x06,Zero,Zero,Zero})
    Name (_S5, Package (0x04){0x07,Zero,Zero,Zero})
    
    OperationRegion (EXTM, SystemMemory, 0x000FF830, 0x10)
    Field (EXTM, WordAcc, NoLock, Preserve)
    {
        ROM1,   16, 
        RMS1,   16, 
        ROM2,   16, 
        RMS2,   16, 
        ROM3,   16, 
        RMS3,   16, 
        AMEM,   32
    }

    OperationRegion (DEBG, SystemIO, 0x80, One)
    Field (DEBG, ByteAcc, NoLock, Preserve)
    {
        DBG1,   8
    }

    OperationRegion (PMRS, SystemIO, 0x0430, 0x13)
    Field (PMRS, ByteAcc, NoLock, Preserve)
    {
        	,   4,
        SLPE,   1,
                Offset (0x08),
        GPSE,   16, 
        GPSS,   16,
                Offset (0x12),
            ,   1, 
        SWGC,   1 
    }

    Method (_PTS, 1, NotSerialized)                                 // This is mm67's revised _PTS method for allowing shutdown.
    {
        Or (Arg0, 0xF0, Local0)
 	    Store (Local0, DBG1)
		Store (Zero, \_SB.PCI0.LPCB.AG3E)                   // Return to S5 after a power failure
        If (LEqual (Arg0, 0x05))
        {
            Store (Zero, SLPE)
            Sleep(0x10)
        }
    }

    Method (DTGP, 5, NotSerialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */    0xC6, 0xB7, 0xB5, 0xA0, 0x18, 0x13, 0x1C, 0x44, 
                    /* 0008 */    0xB0, 0xC9, 0xFE, 0x69, 0x5E, 0xAF, 0x94, 0x9B
                }))
        {
            If (LEqual (Arg1, One))
            {
                If (LEqual (Arg2, Zero))
                {
                    Store (Buffer (One)
                        {
                            0x03
                        }, Arg4)
                    Return (One)
                }

                If (LEqual (Arg2, One))
                {
                    Return (One)
                }
            }
        }
        Store (Buffer (One)
            {
                0x00
            }, Arg4)
        Return (Zero)
    }

    Method (_WAK, 1, NotSerialized)
    {
        Store (0xFF, DBG1)
        Notify (\_SB.PWRB, 0x02)
        Notify (\_SB.PCI0.UHC1, Zero)
        Notify (\_SB.PCI0.UHC2, Zero)
        Notify (\_SB.PCI0.UHC3, Zero)
        Notify (\_SB.PCI0.UHC4, Zero)
        Notify (\_SB.PCI0.UHC5, Zero)
        Notify (\_SB.PCI0.UHC6, Zero)
        Return (Package (0x02){Zero,Zero})
    }

    Scope (_SI)
    {
        Method (_MSG, 1, NotSerialized)
        {
            Store ("Local0", Local0)
        }

        Method (_SST, 1, NotSerialized)
        {
            Store ("Local0", Local0)
        }
    }

    Scope (_GPE)                                                    // General Purpose Events - General events in GPE register block
    {
        Method (_L03, 0, NotSerialized)                             // Handle level 3
        {
            Notify (\_SB.PCI0.UHC1, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L04, 0, NotSerialized)                             // Handle level 4
        {
            Notify (\_SB.PCI0.UHC2, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L0C, 0, NotSerialized)                             // Handle level 12
        {
            Notify (\_SB.PCI0.UHC3, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L0E, 0, NotSerialized)                             // Handle level 14
        {
            Notify (\_SB.PCI0.UHC4, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L05, 0, NotSerialized)                             // Handle level 5
        {
            Notify (\_SB.PCI0.UHC5, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L20, 0, NotSerialized)                             // Handle level 32
        {
            Notify (\_SB.PCI0.UHC6, 0x02)
            Notify (\_SB.PWRB, 0x02)
        }
        Method (_L0D, 0, NotSerialized)                             // Handle level 17
        {
            Notify (\_SB.PCI0.EHC1, 0x02)
            Notify (\_SB.PCI0.EHC2, 0x02)
            Notify (\_SB.PWRB, 0x02)
            Notify (\_SB.PCI0.HDEF, 0x02)                           // Blackosx added for HDEF
            Notify (\_SB.PCI0.IGBE, 0x02)
        }
        Method (_L02, 0, NotSerialized)                             // Handle level 2
        {
            Store (Zero, SWGC)
            ShiftLeft (One, 0x0A, Local0)
            Store (0x02, Local2)
            Store (One, Local3)
            Store (Local3, Local4)
            While (LAnd (LNotEqual (Local4, Zero), LNotEqual (Local2, Zero)))
            {
                Sleep (One)
                Decrement (Local2)
                And (GPSS, Local0, Local1)
                If (LNotEqual (Local1, Local0))
                {
                    Decrement (Local4)
                }
                Else
                {
                    Store (Local3, Local4)
                }
            }
            And (GPSS, Local0, GPSS)
            Or (GPSE, Local0, GPSE)
        }
        Method (_L0B, 0, NotSerialized)                             // Handle level 11
        {
            Notify (\_SB.PCI0.PCIB, 0x02)
        }
        Method (_L09, 0, NotSerialized)                             // Handle level 9
        {
            Notify (\_SB.PCI0.PEX0, 0x02)                           // 0x02 is a Wake event.
            Notify (\_SB.PCI0.PEX1, 0x02)
            Notify (\_SB.PCI0.PEX2, 0x02)
            Notify (\_SB.PCI0.PEX3, 0x02)
            Notify (\_SB.PCI0.PEX4, 0x02)
            Notify (\_SB.PCI0.PEX5, 0x02)
        }

        /*
        Method (_L1A, 0, NotSerialized)                             // Blackosx commented out as not using FRWR
        {
            Notify (\_SB.PCI0.PCIB.FRWR, Zero)
            Notify (\_SB.PWRB, 0x02)
        } */
    }

    Scope (_SB)
    {
        Device (PWRB)
        {
            Name (_CID, EisaId ("PNP0C0C"))
            Method (_STA, 0, NotSerialized)
            {
                Return (0x0B)
            }
        }

        Method (_INI, 0, NotSerialized)                             // Includes mm67's Aluminium Keyboard Wake Fix
        {
            Store (0x01,\_SB.PCI0.EHC1.WRTA)
            Store (0x19, \_SB.PCI0.EHC1.PMES) 
            Store (0x00,\_SB.PCI0.EHC1.WRTA)
	
            Store (0x01,\_SB.PCI0.EHC2.WRTA)
            Store (0x19, \_SB.PCI0.EHC2.PMES) 
            Store (0x00,\_SB.PCI0.EHC2.WRTA)
        }

        Device (PCI0)
        {
            Name (_HID, EisaId ("PNP0A03"))
            Name (_ADR, Zero)
            Name (_UID, One)                                        // Sets PCI-root device UID value to 0
            Name (_BBN, Zero)
            Name (_STA, 0x0F)
            Method (_CRS, 0, NotSerialized)
            {
                Name (BUF0, ResourceTemplate ()
                {
                    WordBusNumber (ResourceConsumer, MinNotFixed, MaxNotFixed, PosDecode,
                        0x0000,             // Granularity
                        0x0000,             // Range Minimum
                        0x003F,             // Range Maximum
                        0x0000,             // Translation Offset
                        0x0040,             // Length
                        ,, )
                    IO (Decode16,
                        0x0CF8,             // Range Minimum
                        0x0CF8,             // Range Maximum
                        0x01,               // Alignment
                        0x08,               // Length
                        )
                    WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                        0x0000,             // Granularity
                        0x0000,             // Range Minimum
                        0x0CF7,             // Range Maximum
                        0x0000,             // Translation Offset
                        0x0CF8,             // Length
                        ,, , TypeStatic)
                    WordIO (ResourceProducer, MinFixed, MaxFixed, PosDecode, EntireRange,
                        0x0000,             // Granularity
                        0x0D00,             // Range Minimum
                        0xFFFF,             // Range Maximum
                        0x0000,             // Translation Offset
                        0xF300,             // Length
                        ,, , TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000A0000,         // Range Minimum
                        0x000BFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00020000,         // Length
                        ,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x000C0000,         // Range Minimum
                        0x000DFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0x00020000,         // Length
                        ,, , AddressRangeMemory, TypeStatic)
                    DWordMemory (ResourceProducer, PosDecode, MinFixed, MaxFixed, Cacheable, ReadWrite,
                        0x00000000,         // Granularity
                        0x00100000,         // Range Minimum
                        0xFEBFFFFF,         // Range Maximum
                        0x00000000,         // Translation Offset
                        0xFFF00000,         // Length
                        ,, _Y00, AddressRangeMemory, TypeStatic)
                })
                CreateDWordField (BUF0, _Y00._MIN, TCMM)
                CreateDWordField (BUF0, _Y00._LEN, TOMM)
                Add (AMEM, 0x00010000, TCMM)
                Add (TCMM, 0x00010000, TCMM)
                Subtract (0xFEC00000, TCMM, TOMM)
                Return (BUF0)
            }
            Method (_PRT, 0, NotSerialized)                         // PCI Routing Table
            {
                Return (Package (0x1B)
                {
                    Package (0x04){0x1BFFFF,Zero,Zero,0x16},
                    Package (0x04){0x1FFFF,Zero,Zero,0x10},
                    Package (0x04){0x1FFFF,One,Zero,0x11},
                    Package (0x04){0x1FFFF,0x02,Zero,0x12},
                    Package (0x04){0x1FFFF,0x03,Zero,0x13},
                    Package (0x04){0x6FFFF,Zero,Zero,0x10},
                    Package (0x04){0x6FFFF,One,Zero,0x11},
                    Package (0x04){0x6FFFF,0x02,Zero,0x12},
                    Package (0x04){0x6FFFF,0x03,Zero,0x13},
                    Package (0x04){0x1CFFFF,Zero,Zero,0x10},
                    Package (0x04){0x1CFFFF,One,Zero,0x11},
                    Package (0x04){0x1CFFFF,0x02,Zero,0x12},
                    Package (0x04){0x1CFFFF,0x03,Zero,0x13},
                    Package (0x04){0x1CFFFF,Zero,Zero,0x10},
                    Package (0x04){0x1CFFFF,One,Zero,0x11},
                    Package (0x04){0x1DFFFF,Zero,Zero,0x17},
                    Package (0x04){0x1DFFFF,One,Zero,0x13},
                    Package (0x04){0x1DFFFF,0x02,Zero,0x12},
                    Package (0x04){0x1DFFFF,0x03,Zero,0x10},
                    Package (0x04){0x1FFFFF,One,Zero,0x13},
                    Package (0x04){0x1FFFFF,One,Zero,0x13},
                    Package (0x04){0x1FFFFF,0x02,Zero,0x12},
                    Package (0x04){0x19FFFF,Zero,Zero,0x14},
                    Package (0x04){0x1AFFFF,Zero,Zero,0x10},
                    Package (0x04){0x1AFFFF,One,Zero,0x15},
                    Package (0x04){0x1AFFFF,0x02,Zero,0x12},
                    Package (0x04){0x1AFFFF,0x02,Zero,0x12}
                })
            }

            Device (PEX0)
            {
                Name (_ADR, 0x001C0000)                             // (Intel Bus 0:Device 28:Function 0 - PCI Express Port 1)
                Name (_STA, 0x0F)
                Name (_PRW, Package (0x02){0x09,0x05})
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x10}, 
                        Package (0x04){0xFFFF,One,Zero,0x11}, 
                        Package (0x04){0xFFFF,0x02,Zero,0x12}, 
                        Package (0x04){0xFFFF,0x03,Zero,0x13}
                    })
                }
            }

            Device (PEX1)
            {
                Name (_ADR, 0x001C0001)                             // (Intel Bus 0:Device 28:Function 1 - PCI Express Port 2)
                Name (_STA, 0x0F)
                Name (_PRW, Package (0x02){0x09,0x05})
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x11}, 
                        Package (0x04){0xFFFF,One,Zero,0x12}, 
                        Package (0x04){0xFFFF,0x02,Zero,0x13}, 
                        Package (0x04){0xFFFF,0x03,Zero,0x10}
                    })
                }
            }

            Device (PEX2)
            {
                Name (_ADR, 0x001C0002)                             // (Intel Bus 0:Device 28:Function 2 - PCI Express Port 3)
                Name (_STA, 0x0F)
                Name (_PRW, Package (0x02){0x09,0x05})
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x12}, 
                        Package (0x04){0xFFFF,One,Zero,0x13}, 
                        Package (0x04){0xFFFF,0x02,Zero,0x10}, 
                        Package (0x04){0xFFFF,0x03,Zero,0x11}
                    })
                }
            }

            Device (PEX3)
            {
                Name (_ADR, 0x001C0003)                             // (Intel Bus 0:Device 28:Function 3 - PCI Express Port 4)
                Name (_STA, 0x0F)
                Name (_PRW, Package (0x02){0x09,0x05})
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x13},
                        Package (0x04){0xFFFF,One,Zero,0x10},
                        Package (0x04){0xFFFF,0x02,Zero,0x11},
                        Package (0x04){0xFFFF,0x03,Zero,0x12}
                    })
                }
            }

            Device (PEX4)
            {
                Name (_ADR, 0x001C0004)                             // (Intel Bus 0:Device 28:Function 4 - PCI Express Port 5)
                Name (_STA, 0x0F)
                Name (_PRW, Package (0x02){0x09,0x05})
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x10},
                        Package (0x04){0xFFFF,One,Zero,0x11},
                        Package (0x04){0xFFFF,0x02,Zero,0x12},
                        Package (0x04){0xFFFF,0x03,Zero,0x13}
                    })
                }
            }

            Device (PEX5)
            {
                Name (_ADR, 0x001C0005)                             // (Intel Bus 0:Device 28:Function 5 - PCI Express Port 6)
                Name (_STA, 0x0F)
                Name (_PRW, Package (0x02){0x09,0x05})
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x04)
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x11},
                        Package (0x04){0xFFFF,One,Zero,0x12},
                        Package (0x04){0xFFFF,0x02,Zero,0x13},
                        Package (0x04){0xFFFF,0x03,Zero,0x10}
                    })
                }
                
                /* Commented out as I use Chameleon's device injection 'EthernetBuiltin'
                Device (LAN0)                                       // thiagom - Device added with DTGP Method - Updated 
                {
                    Name (_ADR, 0x00)
                    Name (_PRW, Package (0x02){0x09,0x03})  // ? - last piece of cade here is 0x03, every other one reads 0x05?
                    Method (_DSM, 4, NotSerialized)
                    {
                        Store (Package (0x06)
                        {
                            "built-in" ,Buffer (0x01){0x01},
                            "location" ,Buffer (0x02){"1"},
                            "device_type" ,Buffer (0x09){"ethernet"} 
                        }, Local0)
                        DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                        Return (Local0)
                    }
                } */
            }

            Device (PCIB)
            {
                Name (_ADR, 0x001E0000)                             // (Intel Bus 0:Device 30:Function 0 - PCI-PCI Bridge)
                Name (_STA, 0x0F)
                Method (_PRT, 0, NotSerialized)
                {
                    Return (Package (0x08) 
                    {
                        Package (0x04){0xFFFF,Zero,Zero,0x14}, 
                        Package (0x04){0xFFFF,One,Zero,0x13}, 
                        Package (0x04){0xFFFF,0x02,Zero,0x12},
                        Package (0x04){0xFFFF,0x03,Zero,0x10},
                        Package (0x04){0x1FFFF,Zero,Zero,0x13},
                        Package (0x04){0x1FFFF,One,Zero,0x12},
                        Package (0x04){0x1FFFF,0x02,Zero,0x10},
                        Package (0x04){0x1FFFF,0x03,Zero,0x14}
                        // Blackosx - Removed superfluous code relevant to mm67's GA-EP45-UD3 and set Package number to 0x08
                    })
                }
                Name (_PRW, Package (0x02){0x0B,0x05})

                // Blackosx removed Device (FRWR) from mm67's original DSDT as my motherboard doesn't use Firewire
                // Blackosx removed Device (WLAN) from mm67's original DSDT as my motherboard doesn't use Wireless

            }

            Device (LPCB)
            {
                Name (_ADR, 0x001F0000)                             // (Intel Bus 0:Device 31:Function 0 - LPC Controller)
                OperationRegion (LPC0, PCI_Config, 0xA4, 0x02)
                Field (LPC0, ByteAcc, NoLock, Preserve)
                {
                    AG3E,   1
                }

                Device (SYSR)
                {
                    Name (_HID, EisaId ("PNP0C02"))
                    Name (_UID, One)
                    Name (_CRS, ResourceTemplate ()
                    {
                        // Decode16 means IO range will use 16bit
                        // Next 4 data items ='Min start addr','Max start addr','Alignment granularity?','Length (no. bytes in IO range)'
                        IO (Decode16, 0x0010, 0x0010, 0x01, 0x10, )
                        IO (Decode16, 0x0022, 0x0022, 0x01, 0x1E, )
                        IO (Decode16, 0x0044, 0x0044, 0x01, 0x1C, )
                        IO (Decode16, 0x0062, 0x0062, 0x01, 0x02, )
                        IO (Decode16, 0x0065, 0x0065, 0x01, 0x0B, )
                        IO (Decode16, 0x0074, 0x0074, 0x01, 0x0C, )
                        IO (Decode16, 0x0091, 0x0091, 0x01, 0x03, )
                        IO (Decode16, 0x00A2, 0x00A2, 0x01, 0x1E, )
                        IO (Decode16, 0x00E0, 0x00E0, 0x01, 0x10, )
                        IO (Decode16, 0x04D0, 0x04D0, 0x01, 0x02, )
                        IO (Decode16, 0x0290, 0x0290, 0x01, 0x10, )
                        IO (Decode16, 0x0800, 0x0800, 0x01, 0x80, )
                        IO (Decode16, 0x0290, 0x0290, 0x01, 0x05, )
                        IO (Decode16, 0x0880, 0x0880, 0x01, 0x10, )
                    })
                }

                Device (IPIC)
                {
                    Name (_HID, EisaId ("PNP0000"))                 // Creates a device named IPIC and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0000"
                    Name (_CRS, ResourceTemplate ()
                    {
                        // Decode16 means IO range will use 16bit
                        // Next 4 data items ='Min start addr','Max start addr','Alignment granularity?','Length (no. bytes in IO range)'
                        IO (Decode16, 0x0020, 0x0020, 0x01, 0x02, )
                        IO (Decode16, 0x00A0, 0x00A0, 0x01, 0x02, )
                    })
                }

                Device (DMAC)
                {
                    Name (_HID, EisaId ("PNP0200"))                 // Creates a device named DMAC and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0200"
                    Name (_CRS, ResourceTemplate ()
                    {
                        DMA (Compatibility, BusMaster, Transfer8, )
                            {4}
                        // Decode16 means IO range will use 16bit
                        // Next 4 data items ='Min start addr','Max start addr','Alignment granularity?','Length (no. bytes in IO range)'
                        IO (Decode16, 0x0000, 0x0000, 0x00, 0x10, )
                        IO (Decode16, 0x0081, 0x0081, 0x00, 0x03, )
                        IO (Decode16, 0x0087, 0x0087, 0x00, 0x01, )
                        IO (Decode16, 0x0089, 0x0089, 0x00, 0x03, )
                        IO (Decode16, 0x008F, 0x008F, 0x00, 0x01, )
                        IO (Decode16, 0x00C0, 0x00C0, 0x00, 0x20, )
                    })
                }

                Device (TIMR)
                {
                    Name (_HID, EisaId ("PNP0100"))                 // Creates a device named TIMR and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0100"
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0040, 0x0040, 0x00, 0x04, )
                    })
                }

                Device (HPET)
                {
                    Name (_HID, EisaId ("PNP0103"))                 // Creates a device named HPET and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0103"
                    Name (_STA, 0x0F)
                    Name (_CRS, ResourceTemplate ()
                    {
                        IRQNoFlags ()
                            {0}
                        IRQNoFlags ()
                            {8}
                        Memory32Fixed (ReadWrite,
                            0xFED00000,         // Address Base
                            0x00000400,         // Address Length
                            )
                    })
                }

                Device (RTC)
                {
                    Name (_HID, EisaId ("PNP0B00"))                 // Creates a device named RTC and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0B00"
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x0070, 0x0070, 0x00, 0x02, )
                    })
                }

                Device (MATH)
                {
                    Name (_HID, EisaId ("PNP0C04"))                 // Creates a device named MATH and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0C04"
                    Name (_CRS, ResourceTemplate ()
                    {
                        IO (Decode16, 0x00F0, 0x00F0, 0x01, 0x10, )
                    })
                }

                /* Blackosx - Commented this out as I had previously done so with other DSDT built from MasterChief's DSDT's
                Device (PMIO)
                {
                    Name (_HID, EisaId ("PNP0C02"))                 // Creates a device named PMIO and associates the Plug and
                                                                    // Play identifier (through the _HID object) of "PNP0C02"
                    Name (_UID, 0x02)
                    Method (_CRS, 0, NotSerialized)
                    {
                        Name (BUF0, ResourceTemplate ()
                        {
                            IO (Decode16, 0x0400, 0x0400, 0x01, 0xD0, )
                            IO (Decode16, 0x04D2, 0x04D2, 0x01, 0x2E, )
                        })
                        Return (BUF0)
                    }
                } */

                Device (FWHD)
                {
                    Name (_HID, EisaId ("INT0800"))
                    Method (_CRS, 0, NotSerialized)
                    {
                        Name (FWH0, ResourceTemplate ()
                        {
                            Memory32Fixed (ReadWrite,
                            0xFFB80000,         // Address Base
                            0x00080000,         // Address Length
                            )
                        })
                    Return (FWH0)
                    }
                }
            }

            Device (IGBE)
            {
                Name (_ADR, 0x00190000)                             // (Intel Bus 0:Device 25:Function 0 - Gigabit Ethernet Controller)
                Name (_PRW, Package (0x02) {0x0D,0x04})
            }

            Device (UHC1)
            {
                Name (_ADR, 0x001D0000)                             // (Intel Bus 0:Device 29:Function 0 - USB FS/LS UHCI Controller #1)
                Name (_PRW, Package (0x02){0x03,0x03})
            }

            Device (UHC2)
            {
                Name (_ADR, 0x001D0001)                             // (Intel Bus 0:Device 29:Function 1 - USB FS/LS UHCI Controller #2)
                Name (_PRW, Package (0x02){0x04,0x03})
            }

            Device (UHC3)
            {
                Name (_ADR, 0x001D0002)                             // (Intel Bus 0:Device 29:Function 2 - USB FS/LS UHCI Controller #3)
                Name (_PRW, Package (0x02){0x0C,0x03})
            }

            Device (UHC4)
            {
                Name (_ADR, 0x001A0000)                             // (Intel Bus 0:Device 26:Function 0 - USB FS/LS UHCI Controller #4)
                Name (_PRW, Package (0x02){0x0E,0x03})
            }

            Device (UHC5)
            {
                Name (_ADR, 0x001A0001)                             // (Intel Bus 0:Device 26:Function 1 - USB FS/LS UHCI Controller #5)
                Name (_PRW, Package (0x02){0x05,0x03})
            }

            Device (UHC6)
            {
                Name (_ADR, 0x001A0002)                             // (Intel Bus 0:Device 26:Function 2 - USB FS/LS UHCI Controller #6)
                Name (_PRW, Package (0x02){0x20,0x03})
            }

            Device (EHC1)
            {
                Name (_ADR, 0x001D0007)                             // (Intel Bus 0:Device 29:Function 7 - USB HS EHCI Controller #1)
                Name (_PRW, Package (0x02){0x0D,0x03})
                OperationRegion (PWRC, PCI_Config, 0x52, 0x2F)
                Field (PWRC, ByteAcc, NoLock, Preserve)
                    {
                        	, 11,
                         PMES, 5,
                         Offset (0x2E),
                         WRTA,   1
                    }
            }

            Device (EHC2)
            {
                Name (_ADR, 0x001A0007)                             // (Intel Bus 0:Device 26:Function 7 - USB HS EHCI Controller #2)
                Name (_PRW, Package (0x02){0x0D,0x03})
                OperationRegion (PWRC, PCI_Config, 0x52, 0x2F)
                Field (PWRC, ByteAcc, NoLock, Preserve)
                    {
                        	, 11,
                         PMES, 5,
                         Offset (0x2E),
                         WRTA,   1
                    }
            }

            Device (SATA)
            {
                Name (_ADR, 0x001F0002)
            }

            Device (SBUS)
            {
                Name (_ADR, 0x001F0003)                             // (Intel Bus 0:Device 31:Function 3 - SMBus Controller)
                Device (BUS0)
                {
                    Name (_CID, "smbus")
                    Name (_ADR, Zero)
                    Device (DVL0)
                    {
                        Name (_ADR, 0x57)
                        Name (_CID, "diagsvault")
                    }
                }
            }

            Device (HDEF) // thiagom - Using 'THe KiNG' new HDEF method for ALC888 with DTGP method
            {
                Name (_ADR, 0x001B0000)                             // (Intel Bus 0:Device 27:Function 0 - Intel High Definition Audio Controller)
                Method (_PRW, 0, NotSerialized)
                {
                    Return (Package (0x02)
                    {
                        0x0D, 
                        0x05
                    })
                }

                OperationRegion (HDCS, PCI_Config, 0x54, 0x04)      // Power Management Control/Status.
                Field (HDCS, DWordAcc, NoLock, Preserve)
                {
                        ,   15, 
                    PMES,   1
                }

                Method (_DSM, 4, NotSerialized)
                {
                    Store (Package (0x08)
                    {
                        "subsystem-id", Buffer (0x04){0xA0, 0x00, 0x00, 0x00},
                        "subsystem-vendor-id", Buffer (0x04){0x6B, 0x10, 0x10, 0x10},					
                        "layout-id", Buffer (0x04){0x78, 0x03, 0x00, 0x00},					
                        "PinConfigurations", Buffer (Zero) { }								    
                    }, Local0)
                    DTGP (Arg0, Arg1, Arg2, Arg3, RefOf (Local0))
                    Return (Local0)
                }
            }
        }

        // Question remains if this is necessary?
        /*
        Device (PCI0.EXPL)
        {
            Name (_HID, EisaId ("PNP0C02"))
            Name (_UID, 0x04)
            Method (_CRS, 0, NotSerialized)
            {
                Name (BUF0, ResourceTemplate ()
                {
                    Memory32Fixed (ReadWrite,
                        0xF4000000,         // Address Base
                        0x04000000,         // Address Length
                        )
                })
                Return (BUF0)
            }
        } */
    }
}

